<template>
    <div class="home">
        <h1>SubContractors</h1>
        <ErrorComponent :error-value="error" class="w"/>
        <SuccessComponent :success-value="success" class="w"/>

        <div class="actions">
            <div>

                <label>
                    <input v-model="subName" placeholder="SubContractor Name">
                </label>
            </div>

            <div class="button" @click="CreateSubContractor">Create</div>
        </div>
        <div class="floors">
            <div v-for="(f,i) in subs" class="fh">
                <div class="flex clickable" @click="Toggle(i)">
                    <div class="name">{{f.name}}</div>
                    <div class="tz">{{f.timeZone}}</div>
                </div>
                <Workers v-if="toggle[i]" :sub="f.id"/>
            </div>
        </div>

    </div>
</template>


<style lang='scss' scoped>

    $w: 800px;

    .w {
        box-sizing: border-box;
        width: $w;
        margin: auto;
    }

    .actions {
        display: flex;
        justify-content: space-between;
        width: $w;
        box-sizing: border-box;
        margin: 20px auto;

        input {
            width: 350px;
        }

        input, select {
            padding: 10px 20px;
            box-sizing: border-box;
            height: 40px;
        }
    }

    .button {
        &:hover {
            background: #00000022;
        }

        text-decoration: none;
        color: black;
        border: 1px solid black;
        padding: 10px 20px;
    }

    .clickable {
        cursor: pointer;
    }

    .floors {
        width: 90%;
        max-width: $w;
        margin: auto;

        .fh {
            border: 1px solid black;
        }

        .flex {
            padding: 20px;
            display: flex;
            justify-content: space-between;
        }
    }

</style>

<script lang='ts'>
    import {Component, Vue} from 'vue-property-decorator';
    import {FloorFlyWeightResponse} from "../../../classLibrary/core/floorFlyWeightResponse";
    import {coreApi} from "../init";
    import ErrorComponent from "../components/ErrorComponent.vue";
    import FloorPlans from "../components/FloorPlans.vue";
    import SuccessComponent from "../components/SuccessComponent.vue";
    import {FloorResponse} from "../../../classLibrary/core/floorResponse";
    import {SubContractorLightResponse} from "../../../classLibrary/core/subContractorLightResponse";
    import {CreateSubContractorRequest} from "../../../classLibrary/core/createSubContractorRequest";
    import {SubContractorResponse} from "../../../classLibrary/core/subContractorResponse";
    import Workers from "../components/Workers.vue";

    const props = {};

    const Base = Vue.extend({props});

    @Component({
        components: {Workers, SuccessComponent, FloorPlans, ErrorComponent},
        props
    })
    export default class SubContractorHome extends Base {
        subs: SubContractorLightResponse[] = [];
        toggle: boolean[] = [];
        error = "";
        success = "";

        subName: string = "";

        Toggle(i: any) {
            Vue.set(this.toggle, i, !this.toggle[i]);
        }

        async updateSubContractor() {
            const fr = await coreApi.Get<SubContractorLightResponse[]>("SubContractor");
            if (fr.success) {
                this.subs = fr.Ok!;
                const diff = this.subs.length - this.toggle.length;
                for (let i = 0; i < diff; i++) {
                    this.toggle.push(false);
                }
            } else {
                this.err = fr.error!;
            }
        }

        async created() {

            const r = await coreApi.Get<SubContractorLightResponse[]>("SubContractor");

            if (r.success) {
                const s = r.Ok!;
                this.subs = s!;
                this.toggle = this.subs.Map(x => false);
            } else {
                this.err = r.error ?? "unknown error";
            }
        }


        private get err(): string {
            return this.error;
        }

        private get ok(): string {
            return this.success
        }

        private set err(i: string) {
            this.error = i;
            this.success = "";
        }

        private set ok(i: string) {
            this.error = "";
            this.success = i;
        }

        async CreateSubContractor() {
            if (this.subName == "" || this.subName == null) {
                this.err = "Please enter floor name";
                return;
            }


            const ar = await coreApi.Post<SubContractorResponse>("SubContractor", {
                name: this.subName,
                logo: "lol",
                color: "black",
                data: {},
            });

            if (ar.success) {
                this.ok = `Create SubContractor ${ar.Ok!.light.name}`;
            } else {
                this.err = ar.error!;
            }
            await this.updateSubContractor();
        }
    }
</script>
